#!/usr/bin/perl

# Score all of the WMT11 systems using TER.

$dir = "/Users/ccb/Documents/Projects/WMT12/wmt12-data/plain";

@testSets = ( "newstest2012");

@langs = ("cs", "de", "es", "fr");

@systems = ("CU_TectoMT", "DFKI-hunsicker", "GTH-UPM", "Its-LATL", "KIT_Phrase-Based_SMT_System", "LIMSI-Ncode-Constrained-Primary", "LIUM_EN-FR_12", "LIUM_FR-EN_12", "PROMT_DeepHybrid", "QCRI--primary", "RWTH-Jane2-HPBT-constrained", "RWTH-PBT-constrained", "RWTH_primary", "SFU", "SFU_-_Kriya", "UG-WMT12", "UPC", "cmu-avenue", "commercial2", "cu-bojar", "cu-bojar_2012", "cu-depfix", "cu-poor-comb", "cu-tamch-boj", "dfki-berlin", "jhu-heiro", "jhu-hiero", "onlineA", "onlineB", "onlineC", "onlineD", "onlineE", "onlineF", "pctrans2010", "quaero_primary", "rwth-primary", "uedin-williams", "uedin-wmt12", "uk-dan-moses" );




foreach $testSet (@testSets) {
    foreach $lang (@langs) {
	# INTO ENGLISH
	$refFile = "$dir/references/${testSet}-ref.en";
	foreach $system (@systems) {
	    $systemOutputFile = "$dir/system-outputs/$testSet/$lang-en/$testSet.$lang-en.$system";
	    if(-e $systemOutputFile) {
		$output = `java -cp ~/Code/joshua/bin -Xmx1000m -Xms1000m joshua.util.JoshuaEval -cand $systemOutputFile -ref $refFile -m TER nocase punc 20 50 /Users/ccb/Documents/Projects/WMT11/automatic-evaluation/ter/tercom.7.25.jar 1 | grep "TER = "`;
		@fields = split(/=\s*/, $output);
		$score = $fields[2];
		print "TER\t$lang-en\t$testSet\t$system\t$score";
	    }
	}

	#OUT OF ENGLISH
	$refFile = "$dir/references/${testSet}-ref.$lang";
	foreach $system (@systems) {
	    $systemOutputFile = "$dir/system-outputs/$testSet/en-$lang/$testSet.en-$lang.$system";
	    if(-e $systemOutputFile) {
		$output = `java -cp ~/Code/joshua/bin -Xmx1000m -Xms1000m joshua.util.JoshuaEval -cand $systemOutputFile -ref $refFile -m TER nocase punc 20 50 /Users/ccb/Documents/Projects/WMT11/automatic-evaluation/ter/tercom.7.25.jar 1 | grep "TER = "`;
		@fields = split(/=\s*/, $output);
		$score = $fields[2];
		print "TER\ten-$lang\t$testSet\t$system\t$score";
	    }
	}
    }

}

